
// "UC" stands for "user constant". You can
// adjust the values below as desired. Extreme
// values will, of course, cause peculiar results.

// All dimensions are in millimeters.

// ***************************

// The nominal width of the base of each square of the tile. 
// It is the distance from the center of one square to the next.
// It is reduced by UC_base_aisle to produce the actual width, not shown here.
   UC_nom_wide = 20.0;

// This produces a small gap between tiles so that they will
// not get stuck together, because 3D printers are not exact.
   UC_base_aisle = 0.45;

// The height of the base of each square of the tile.
   UC_base_high = 4.8;

// The height that the stud measures above the base.
   UC_stud_high = 1.6;

// The gap between the side of a stud, and the 
// wall of a tile placed on top of it. This is   
// necessary because 3D printers are not exact.
   UC_stud_aisle = 0.65;

// The thickness of the wall of the base.
   UC_wall_thick = 1.6;

// The thickness of the ceiling of the base.
   UC_ceil_thick = 1.6;

// ***************************

// Your font choice.
   UC_font_face = "Liberation Sans:style=Bold";

// An indirect control over the font size.
// A larger number gives a larger font.
   UC_font_ratio = 0.5;

// How far the letters and numerals of the legend reach
// above the stud. A negative number gives recessed
// characters. Zero gives no characters.
   UC_font_rise = +0.8;

// ***************************

// The hues do not affect the finished product, but they do 
// affect how it appears in the OpenSCAD window. The different
// colors may aid in debugging. In many cases, faces of two 
// elements are intentionally coplanar, and artifacts will appear.
   UC_hue_drk = [0.4, 0.4, 0.4];		
   UC_hue_grn = [0.6, 0.9, 0.6];
   UC_hue_blu = [0.6, 0.8, 1.0];
   UC_hue_red = [1.0, 0.7, 0.7];
   UC_hue_yel = [1.0, 0.9, 0.0];

// ***************************

// Always include this:

include <include_parts.scad>

