
module tile_part_2_base (xt, yt, h_3, h_2) {
	color (UC_hue_drk) {
		translate ([xt, yt, 0]) {
			linear_extrude (UC_base_high) {
				polygon ([[+h_3, +h_3], [+h_3, -h_3],
						  [+h_2, -h_3], [+h_2, +h_3]]);	
				polygon ([[-h_3, +h_3], [+h_3, +h_3],
						  [+h_3, +h_2], [-h_3, +h_2]]);	
				polygon ([[-h_3, -h_3], [-h_3, +h_3],
	   					  [-h_2, +h_3], [-h_2, -h_3]]);	
				polygon ([[+h_3, -h_3], [-h_3, -h_3],
						  [-h_3, -h_2], [+h_3, -h_2]]);	
			}
		}
		translate ([xt, yt, UC_base_high - UC_ceil_thick]) {
			linear_extrude (UC_ceil_thick) {
				polygon ([[+h_3, +h_3], [+h_3, -h_3],					  
						  [-h_3, -h_3], [-h_3, +h_3]]);	
				
			}
		}
	}
}

module tile_part_2_stud (xt, yt, h_1) {
	translate ([xt, yt, UC_base_high - UC_ceil_thick]) {
		linear_extrude(UC_ceil_thick + UC_stud_high) {
			polygon ([[+h_1, +h_1], [+h_1, -h_1],					  
					  [-h_1, -h_1], [-h_1, +h_1]]);				
		}
	}
}

module tile_part_2_text (t, h_2) {
	text (
		text = t,
		halign = "center",
		valign = "center",
		size = h_2 * 2.0 * UC_font_ratio,
		font = UC_font_face
	);
}


module tile_part_2 (hue, x, y, t = "") {
	xt = x * UC_nom_wide / 2;
	yt = y * UC_nom_wide / 2;

	h_3 = UC_nom_wide / 2 - UC_base_aisle;
	h_2 = h_3 - UC_wall_thick;
	h_1 = h_2 - UC_stud_aisle;

	tile_part_2_base (xt, yt, h_3, h_2);

	if (! t) {
		color (hue) {
			tile_part_2_stud (xt, yt, h_1);
		}
	} else if (UC_font_rise > 0.0) {
		color (hue) {
			tile_part_2_stud (xt, yt, h_1);
		}
		color (UC_hue_drk) {
			translate ([xt, yt, UC_base_high - UC_ceil_thick]) {
				linear_extrude (UC_stud_high + UC_font_rise + UC_ceil_thick) {
					tile_part_2_text (t, h_2);
				}
			}
		}		
	} else if (UC_font_rise < 0.0) {
		color (hue) {
			difference () {
				tile_part_2_stud (xt, yt, h_1);
				translate ([xt, yt, UC_base_high + UC_stud_high + UC_font_rise]) {
					linear_extrude (UC_stud_high + UC_font_rise + UC_ceil_thick + 1.0) {
						tile_part_2_text (t, h_2);
					}
				}

			}
		}
	} else {
		color (hue) {
			tile_part_2_stud (xt, yt, h_1);
		}
	}	
}

//////////////////////

module tile_part_1 (hue, x, y, v) { 
	xt = x * UC_nom_wide / 2;
	yt = y * UC_nom_wide / 2;
	p = UC_base_aisle + UC_wall_thick;
	q = UC_nom_wide / 2 - UC_base_aisle - UC_wall_thick;

	color (hue) {
		translate ([xt, yt, 0]) {
			linear_extrude(UC_base_high - UC_ceil_thick) {
				if (v) {
					polygon ([[+p, +q], [+p, -q],					  
							  [-p, -q], [-p, +q]]);				
				} else {
					polygon ([[+q, +p], [+q, -p],					  
							  [-q, -p], [-q, +p]]);	
				}
			}
		}
	}
}

//////////////////////

module tile_part_0 (hue, x, y) {
	xt = x * UC_nom_wide / 2;
	yt = y * UC_nom_wide / 2;
	p = UC_base_aisle + UC_wall_thick;

	color (hue) {
		translate ([xt, yt, 0]) {
			linear_extrude(UC_base_high - UC_ceil_thick) {
				polygon ([[+p, +p], [+p, -p],					  
  						  [-p, -p], [-p, +p]]);	
				
			}
		}
	}
}

